/*
    Парус 8 - Панели мониторинга - ТОиР - Прогнозирование технического состояния
    Дополнительная разметка и вёрстка клиентских элементов
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import { Box, Card, CardContent, Typography, CardActions, Button } from "@mui/material"; //Интерфейсные компоненты

//-----------
//Тело модуля
//-----------

const TechObjCard = ({ cardData }) => {
    //Генерация содержимого
    return (
        <Box p={3}>
            <Card>
                <CardContent>
                    <Typography sx={{ fontSize: 14 }} color="text.secondary" gutterBottom>
                        Технологический объект
                    </Typography>
                    <Typography variant="h5" component="div">
                        {cardData.SCODE}
                    </Typography>
                    <Typography sx={{ mb: 1.5 }} color="text.secondary">
                        {cardData.DOPER_DATE}
                    </Typography>
                    <Typography variant="body2">{cardData.SNAME}</Typography>
                </CardContent>
                <CardActions>
                    <Button size="large">Прогнозировать</Button>
                    <Button size="large">Ремонтировать</Button>
                    <Button size="large">Обучать</Button>
                </CardActions>
            </Card>
        </Box>
    );
};

//----------------
//Интерфейс модуля
//----------------

export { TechObjCard };
